Skip to main content

Binary Search - Interview Questions - Question 1

Binary Search - Interview Questions - Question 1


Minimum steps to find a baseball

One baseball has been placed at one spot in an m * n matrix, and we want to quickly find the location of the baseball. For each move (can pick up any locations), the only thing we know is that we are getting closer or further from the baseball comparing to the previous position. A Boolean helper API is provided for this information: helper(x1, y1, x2, y2), where (x1, y1) is the former position and (x2, y2) the current position. When helper(x1, y1, x2, y2) is true, it means closer; false for further. Design an algorithm to find the location.


Analysis:

Suppose the baseball is at (x0, y0), and the matrix size is known as m * n.

If we are on the top side of the matrix above X = x0, then every move down would get us closer to the target; if we are at the down side below X = x0, then every move up gets us closer too.

The horizontal direction can give us the similar results. So we can reduce the 2D problem to 1D.

Let focus on the X directory (or the vertical). If we are at [0, x0-1], then every move down will make the distance smaller; X=x0 will give the minimum; [x0+1, m) will get the distance larger as X increases. The overall behavior of distance as a function of X is like a "V" shape.

So one way to find the baseball is that, we can just make a try first: to move up or down, if one of them gets us closer, choose that direction; if both of them get us further from the baseball, then X is x0 now. Then we apply the same method to the Y direction.


See the code below:


class Solution {
public:
    vector<int, int> findIdx(int m, int n) {
        int x = findX(0, m), y = findY(0, n);
        if(x == -1 || y == -1) {
            cout<<"cannot find"<<endl;
        }
        return {x, y};
    }

private:
    // true for getting closer; false for further
    // can directly call without worrying about the implementation details
    bool helper(int x1, int y1, int x2, int y2){
        
    };

    // return -1 if does not find
    int findX(int x, int range) {
        if(x < 0 || || range < 1 || x >= range) {
            cout<<"wrong range or index"<<endl;
            return -1;
        }
        // some base cases
        if(range == 1) return x;
        if(x == 0 && !helper(x, 0, x+1, 0)) return x;
        if(x + 1 == range && !helper(x, 0, x-1, 0)) return x;
        int up = x - 1, down = x + 1;
        if(up >= 0 || down < range) {
            if(up >= 0 && helper(x, 0, up, 0)) return findX(up, range);
            if(down < range && helper(x, 0, down, 0)) return findX(down, range);
            // find it
            if(up >= 0 && down < range && !helper(x, 0, up, 0) && !helper(x, 0, down, 0)) {
                return x;
            }
        }
        return -1;
    }

    // return -1 if does not find
    int findY(int y, int range) {
        if(y < 0 || range < 1 || y >= range) {
            cout<<"wrong range or index"<<endl;
            return -1;
        }
        // some base cases
        if(range == 1) return y;
        if(y == 0 && !helper(0, y, 0, y+1)) return y;
        if(y + 1 == range && !helper(0, y, 0, y-1)) return y;
        int left = y - 1, right = y + 1;
        if(left >= 0 || right < range) {
            if(left >= 0 && helper(0, y, 0, left)) return findY(left, range);
            if(down < range && helper(0, y, 0, right)) return findY(right, range);
            // find it
            if(left >= 0 && right < range && !helper(0, y, 0, left) && !helper(0, y, 0, right)) {
                return y;
            }
        }
        return -1;
    }
};


The time complexity is O(m + n). Can we do better?

The answer is yes! we can apply binary search to this question, since the search space is kind of sorted, or more specific, it has a "V" shape.

The basic idea is as the following:

Again let focus on the X direction only. The search range is [0, m), the first guess is mid = m/2.  Different from the common binary search, we still need a second guess to use the helper() function. The second guess can be mid+1, then the helper() function can tell us it gets closer or further from mid to mid+1.

If get closer, then the search range becomes [mid+1, m); if not, the search range can be updated as [0, mid+1).

The same procedure can be applied to the Y direction.

The overall time complexity is O(log(m) + log(n)), or O(log(m*n)). 

class Solution {
public:
    vector<int, int> findIdx(int m, int n) {
        int x = findX(0, m-1), y = findY(0, n-1);
        if(x == -1 || y == -1) {
            cout<<"cannot find"<<endl;
        }
        return {x, y};
    }

private:
    // true for getting closer; false for further
    // can directly call without worrying about the implementation details
    bool helper(int x1, int y1, int x2, int y2){
        
    };

    // return -1 if does not find
    int findX(int left, int right) {
        if(left > right) {
            cout<<"wrong range or index"<<endl;
            return -1;
        }
        if(left == right) return left;
        int mid = left + (right - left) / 2;
        if(helper(mid, 0, mid+1, 0)) findX(mid+1, right);
        return findX(left, mid);
    }

    // return -1 if does not find
    int findY(int left, int right) {
        if(left > right) {
            cout<<"wrong range or index"<<endl;
            return -1;
        }
        if(left == right) return left;
        int mid = left + (right - left) / 2;
        if(helper(0, mid, 0, mid+1)) findY(mid+1, right);
        return findY(left, mid);
    }
};


Note:

In general, m*n >> m + n, but log(m*n) usually << m + n



Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...